# Tree-based methods

# Q1
library("Ecdat")
data(Hdma)
N<-nrow(Hdma)

boxplot(dir~deny,data=Hdma)
boxplot(hir~deny,data=Hdma)
boxplot(lvr~deny,data=Hdma)

barplot(table(Hdma$deny[1:2380],Hdma$ccs[1:2380]),beside=TRUE)
barplot(table(Hdma$deny[1:2380],Hdma$mcs[1:2380]),beside=TRUE)

table(Hdma$pbcr,Hdma$deny)
table(Hdma$self,Hdma$deny)

# Q2
train = sample(1:N, 1500)

# Q3
library("tree")
tree.hdma=tree(deny~.,data=Hdma,subset=train,mindev=0.005)
summary(tree.hdma)
plot(tree.hdma)
text(tree.hdma,pretty=0)

# prediction
yhat=predict(tree.hdma,newdata=Hdma[-train,],type='class')
y.test=Hdma[-train,"deny"]
table(y.test,yhat)
print(1-mean(y.test==yhat))

# Q4

cv.hdma=cv.tree(tree.hdma)
plot(cv.hdma$size,cv.hdma$dev,type='b')

Size<-cv.tree(tree.hdma)$size
DEV<-rep(0,length(Size))
for(i in (1:10)){
  cv.hdma=cv.tree(tree.hdma)
  DEV<-DEV+cv.hdma$dev
}
DEV<-DEV/10
plot(cv.hdma$size,DEV,type='b')

prune.hdma=prune.tree(tree.hdma,best=6)
plot(prune.hdma)
text(prune.hdma,pretty=0)

# prediction
yhat=predict(prune.hdma,newdata=Hdma[-train,],type='class')
table(y.test,yhat)
print(1-mean(y.test==yhat))

# Q5
library('randomForest')

# Bagging
bag.hdma=randomForest(deny~.,data=Hdma,subset=train,mtry=13)
yhat1=predict(bag.hdma,newdata=Hdma[-train,],type='response')
table(y.test,yhat1)
1-mean(y.test==yhat1)

# random forest
bag.hdma=randomForest(deny~.,data=Hdma,subset=train,mtry=4)
yhat1=predict(bag.hdma,newdata=Hdma[-train,],type='response')
table(y.test,yhat1)
1-mean(y.test==yhat1)

# Q6

# Logistic regression

Hdma.train<-Hdma[train,]
reg<-glm(deny~.,data=Hdma.train,famil='binomial')
proba=predict(reg,newdata=Hdma[-train,],type='response')
yhat2<-(proba>=0.5)
table(y.test,yhat2)
ntest<-2381-1500
(14+80)/ntest

